<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once(APPPATH.'classes/ci_extend_libraries/DatabaseTableModelBase.abstract.php');
	
/**
 * TransactionLogModel クラス
 */
class TransactionLogModel extends DatabaseTableModelBase 
{
	/**
	 * 
	 */
	const LOG_REQUEST  = 1;
	const LOG_SUBMIT   = 2;
	const LOG_RESPONSE = 3;
	const LOG_RESULT   = 4;
	/**
	 * 
	 */
	protected $_current_id = null;
	/**
	 * 
	 */
	protected $_loglink_names = array(
		self::LOG_REQUEST	=> 'REQUEST_ID',
		self::LOG_SUBMIT	=> 'SUBMIT_ID',
		self::LOG_RESPONSE	=> 'RESPONSE_ID',
		self::LOG_RESULT	=> 'RESULT_ID',
	);
	
	/**
	 * テーブル名
	 * @abstract
	 */
	protected $_tablename = 'transaction_log';

	/**
	 * コンストラクタ
	 */
    public function __construct()
    {
        parent::__construct();
    }

	/**
	 * 
	 */
	public function writeLogId($logenum, $logid, $forceid = null)
	{
		// ID の再設定
		if(!is_null($forceid))
			$this->setId($forceid);

		// _current_id が空なら INSERT
		if(empty($this->_current_id))
		{
			// データセット
			$datas[$this->_loglink_names[$logenum]] = $logid;
			// INSERT
			$res = $this->insertArray($datas);
			// ID を保存
			if($res)
				$this->_current_id = $this->getInsertId();
		}
		// 既存レコード UPDATE
		else
		{
			// データセット
			$datas['ID'] = $this->_current_id;
			$datas[$this->_loglink_names[$logenum]] = $logid;
			$keys = array('ID');
			// UPDATE
			$res = $this->updateArray($datas, $keys);
		}
		// 復帰
		if(!$res)
			return null;
		else
			return $this->getId();
	}
	/**
	 * 
	 */
	public function getId()
	{
		return $this->_current_id;
	}
	/**
	 * 
	 */
	public function setId($id = null)
	{
		$this->_current_id = $id;
	}
}

/* End of file */